Contabilidad/Contabilidad.Site/Models/Client/ClientCreateViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Client
{
    public class ClientCreateViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public int Id { get; set; }

        [Display(Name = nameof(BusinessName), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string BusinessName { get; set; }


        [Display(Name = nameof(RTN), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string RTN { get; set; }


        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string Description { get; set; }

        [Display(Name = nameof(Database.Models.Accounting.Client.People), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public int? IdPeople { get; set; }

        [Display(Name = nameof(Peoples), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public IEnumerable<SelectListViewModel> Peoples { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Client/ClientDetailsViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Client
{
    public class ClientDetailsViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public int Id { get; set; }

        [Display(Name = nameof(BusinessName), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string BusinessName { get; set; }

        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string Description { get; set; }

        [Display(Name = nameof(RTN), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string RTN { get; set; }

        [Display(Name = nameof(People), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string People { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Client/ClientEditViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Client
{
    public class ClientEditViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public int Id { get; set; }

        [Display(Name = nameof(BusinessName), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string BusinessName { get; set; }


        [Display(Name = nameof(RTN), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string RTN { get; set; }


        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string Description { get; set; }

        [Display(Name = nameof(Database.Models.Accounting.Client.People), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        [Required(ErrorMessageResourceName = "Required", ErrorMessageResourceType = typeof(Resources.CommonResources))]
        public int? IdPeople { get; set; }

        [Display(Name = nameof(Peoples), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public IEnumerable<SelectListViewModel> Peoples { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Models/Client/ClientListViewModel.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace Contabilidad.Site.Models.Client
{
    public class ClientListViewModel
    {
        [Display(Name = nameof(Id), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public int Id { get; set; }

        [Display(Name = nameof(BusinessName), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string BusinessName { get; set; }

        [Display(Name = nameof(Description), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string Description { get; set; }
        
        [Display(Name = nameof(RTN), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string RTN { get; set; }


        [Display(Name = nameof(People), ResourceType = typeof(Resources.Models.Accounting.Client.Client))]
        public string People { get; set; }
    }
}

Contabilidad/Contabilidad.Site/Controllers/ClientController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Contabilidad.Core.Client;
using Contabilidad.Database.Repositories;
using Contabilidad.Site.Models;
using Contabilidad.Site.Models.Client;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace Contabilidad.Site.Controllers
{
    public class ClientController : Controller
    {
        private readonly IClientManager clientManager;
        private readonly IRepository<Database.Model.People.People> peopleRepository;

        public ClientController(
            IClientManager clientManager,
            IRepository<Database.Model.People.People> peopleRepository)
        {
            this.clientManager = clientManager;
            this.peopleRepository = peopleRepository;
        }
        public async Task<IActionResult> Index(string errorMessage)
        {
            if (!string.IsNullOrEmpty(errorMessage))
            {
                this.ModelState.AddModelError(string.Empty, errorMessage);
            }

            var clients = await this.clientManager.GetAllAsync();
            var model = clients.OrderBy(b => b.People).Select(b => new ClientListViewModel
            {
                Id = b.Id,
                People = b.People?.FullName(),
                BusinessName = b.BusinessName,
                Description = b.Description,
                RTN = b.RTN,
            });

            return View(model);
        }
        public async Task<IActionResult> Create()
        {
            return this.View(new ClientCreateViewModel 
            {
                Peoples = await  this.GetPeoples(),
            });
        }

        public async Task<IActionResult> Delete(int? id)
        {
            if (!id.HasValue)
            {
                return this.BadRequest();
            }

            var client = await this.clientManager.GetByIdAsync(id.Value);

            if (client == null)
            {
                return this.BadRequest();
            }

            var result = await this.clientManager.DeleteAsync(id.Value);
            var errorMessages = new StringBuilder();
            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        errorMessages.Append(item);
                    }
                }

                return this.RedirectToAction(nameof(Index), new { errorMessage = errorMessages });
            }

            return this.RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Edit(int? id)
        {
            if (id == null)
            {
                return this.BadRequest();
            }

            var client = await this.clientManager.GetByIdAsync(id.Value);

            if (client == null)
            {
                return this.BadRequest();
            }

            return this.View(new ClientEditViewModel
            {
                Id = client.Id,
                Peoples = await this.GetPeoples(),
                BusinessName = client.BusinessName,
                Description = client.Description,
                IdPeople = client.IdPeople,
                RTN = client.RTN,
            });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(ClientEditViewModel clientEditViewModel)
        {
            if (!this.ModelState.IsValid)
            {
                clientEditViewModel.Peoples = await this.GetPeoples();
                return this.View(clientEditViewModel);
            }

            var client = await this.clientManager.GetByIdAsync(clientEditViewModel.Id);

            if (client == null)
            {
                return this.BadRequest();
            }

            client.BusinessName = clientEditViewModel.BusinessName;
            client.Description = clientEditViewModel.Description;
            client.IdPeople = clientEditViewModel.IdPeople.Value;
            client.RTN = clientEditViewModel.RTN;

            var result = await this.clientManager.EditAsync(client);

            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        this.ModelState.AddModelError(string.Empty, item);
                    }
                }

                clientEditViewModel.Peoples = await this.GetPeoples();
                return this.View(clientEditViewModel);
            }

            return this.RedirectToAction(nameof(Index));
        }
        public async Task<IActionResult> Details(int? idClient)
        {
            if (idClient == null)
            {
                return this.BadRequest();
            }

            var client = await this.clientManager.GetByIdAsync(idClient.Value);

            if (client == null)
            {
                return this.BadRequest();
            }

            return this.View(new ClientDetailsViewModel
            {
                Id = client.Id,
                People = client.People?.FullName(),
                BusinessName = client.BusinessName,
                Description = client.Description,
                RTN = client.RTN,
            });
        }



        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(ClientCreateViewModel clientCreateViewModel)
        {
            if (!this.ModelState.IsValid)
            {
                clientCreateViewModel.Peoples = await this.GetPeoples();
                return this.View(clientCreateViewModel);
            }

            var result = await this.clientManager.CreateAsync(new Database.Models.Accounting.Client
            {
                BusinessName = clientCreateViewModel.BusinessName,
                IdPeople = clientCreateViewModel.IdPeople.Value,
                Description = clientCreateViewModel.Description,
                RTN = clientCreateViewModel.RTN,
            });

            if (!result.Succeeded)
            {
                foreach (var validations in result.ValidationMessages)
                {
                    foreach (var item in validations.Value)
                    {
                        this.ModelState.AddModelError(string.Empty, item);
                    }
                }

                clientCreateViewModel.Peoples = await this.GetPeoples();
                return this.View(clientCreateViewModel);
            }

            return this.RedirectToAction(nameof(Index));
        }
        private async Task<IEnumerable<SelectListViewModel>> GetPeoples()
        {
            return new List<SelectListViewModel>() {
                new SelectListViewModel
                {
                    Value = Resources.Models.Accounting.Client.Client.PeopleSelect,
                }
            }
            .Union(await this.peopleRepository.All().Select(b => new SelectListViewModel
            {
                Id = b.Id,
                Value = b.FullName(),
            }).ToListAsync());
        }

    }
}

Contabilidad/Contabilidad.Site/Views/Client/Create.cshtml
@model Contabilidad.Site.Models.Client.ClientCreateViewModel
@{
    ViewData["Title"] = @Contabilidad.Resources.CommonResources.Create;
}
<div class="row clearfix">
    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
        <div class="x_panel">
            <div class="x_title">
                <h2>@Contabilidad.Resources.CommonResources.Create @Contabilidad.Resources.Models.Accounting.Client.Client.modelName</h2>
                <div class="clearfix"></div>
            </div>
            <div class="x_content">
                <form method="post" enctype="multipart/form-data">
                    @if (ViewData.ModelState[string.Empty]?.Errors?.Any() == true)
                    {
                        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                            <div class="card">
                                <div class="body bg-red">
                                    <div asp-validation-summary="ModelOnly"></div>
                                </div>
                            </div>
                        </div>
                    }

                    <label asp-for="BusinessName">@Html.DisplayNameFor(Model => Model.BusinessName)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <input asp-for="BusinessName" class="form-control" />
                        </div>
                        <ul class="parsley-errors-list filled" id="parsley-id-5">
                            <li>
                                <span asp-validation-for="BusinessName"></span>
                            </li>
                        </ul>
                    </div>

                    <label asp-for="RTN">@Html.DisplayNameFor(Model => Model.RTN)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <input asp-for="RTN" class="form-control" />
                        </div>
                        <ul class="parsley-errors-list filled" id="parsley-id-5">
                            <li>
                                <span asp-validation-for="RTN"></span>
                            </li>
                        </ul>
                    </div>

                    <label asp-for="Description">@Html.DisplayNameFor(Model => Model.Description)</label>
                    <div class="form-group">
                        <div class="form-line">
                            <input asp-for="Description" class="form-control" />
                        </div>
                        <ul class="parsley-errors-list filled" id="parsley-id-5">
                            <li>
                                <span asp-validation-for="Description"></span>
                            </li>
                        </ul>
                    </div>

                    <div class="form-group">
                        <label asp-for="IdPeople">@Html.DisplayNameFor(Model => Model.IdPeople)</label>
                        <div class="form-line">
                            <select class="form-control selectpicker" title="@Html.DisplayNameFor(Model => Model.Peoples)" asp-for="IdPeople" data-live-search="true" asp-items="@(new SelectList(Model.Peoples,"Id","Value"))"></select>
                        </div>
                        <ul class="parsley-errors-list filled">
                            <li>
                                <span asp-validation-for="IdPeople"></span>
                            </li>
                        </ul>
                    </div>

                    <div align="right">
                        <a href="#confirm" class="btn btn-primary waves-effect" data-toggle="modal" data-target="#confirm">@Contabilidad.Resources.CommonResources.SaveChanges</a>
                    </div>
                    <div class="modal fade" id="confirm" tabindex="-1" role="dialog">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h4 class="modal-title" id="defaultModalLabel">@Contabilidad.Resources.CommonResources.Create @Contabilidad.Resources.Models.Accounting.Client.Client.modelName</h4>
                                </div>
                                <div class="modal-body">
                                    @Contabilidad.Resources.Models.Accounting.Client.Client.CreateMessage
                                </div>
                                <div class="modal-footer">
                                    <input type="submit" id="submitbutton" value="@Contabilidad.Resources.CommonResources.SaveChanges" data-disableonclick="true" class="btn btn-primary waves-effect" />
                                    <button type="button" class="btn btn-default waves-effect" data-dismiss="modal">@Contabilidad.Resources.CommonResources.Cancel</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

Contabilidad/Contabilidad.Site/Views/Client/Details.cshtml
@model Contabilidad.Site.Models.Client.ClientDetailsViewModel
@{
    ViewData["Title"] = @Contabilidad.Resources.CommonResources.Details;
}

<div class="row clearfix">
    <div class="col-lg-6 col-md-6 col-sm-12 col-xs-12">
        <div class="x_panel">
            <div class="x_title">
                <h2>
                    @Contabilidad.Resources.Models.Accounting.Client.Client.DetailsTitle
                </h2>
                <div class="clearfix"></div>
            </div>
            <div class="x_content">
                <div>
                    <dl class="dl-horizontal">
                        <dt>
                            @Html.DisplayNameFor(model => model.People)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.People)
                        </dd>
                        <dt>
                            @Html.DisplayNameFor(model => model.BusinessName)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.BusinessName)
                        </dd>
                        <dt>
                            @Html.DisplayNameFor(model => model.RTN)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.RTN)
                        </dd>
                        <dt>
                            @Html.DisplayNameFor(model => model.Description)
                        </dt>
                        <dd>
                            @Html.DisplayFor(model => model.Description)
                        </dd>
                    </dl>
                </div>

                <br />
                <div class="row clearfix">
                    <div class="col-xs-6 col-sm-3 col-md-2 col-lg-2">
                        <a href="#confirm_@Model.Id" data-loader="true" class="btn btn-primary"
                           data-toggle="modal" data-target="#confirm_@Model.Id">@Contabilidad.Resources.CommonResources.Delete</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<form asp-action="Delete" asp-route-id="@Model.Id">
    <div class="modal fade" id="confirm_@Model.Id" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="defaultModalLabel">@Contabilidad.Resources.CommonResources.Delete @Contabilidad.Resources.Models.Accounting.Client.Client.modelName</h4>
                </div>
                <div class="modal-body">
                    @Contabilidad.Resources.Models.Accounting.Client.Client.MessageDelete
                </div>
                <div class="modal-footer">
                    <input type="submit" value="@Contabilidad.Resources.CommonResources.Delete" data-loader="true" class="btn btn-danger waves-effect" />
                    <button type="button" class="btn btn-default waves-effect" data-dismiss="modal">@Contabilidad.Resources.CommonResources.Cancel</button>
                </div>
            </div>
        </div>
    </div>
</form>

Contabilidad/Contabilidad.Site/Views/Client/Index.cshtml
@model IEnumerable<Contabilidad.Site.Models.Client.ClientListViewModel>
@{
    ViewData["Title"] = "Index";
}

<div class="row clearfix">
    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
        <div class="x_panel">
            <div class="x_title">
                <h2>@Contabilidad.Resources.Models.Accounting.Client.Client.TitlePage</h2>
                <div class="clearfix"></div>
            </div>

            <div class="x_content">
                @if (ViewData.ModelState[string.Empty]?.Errors?.Any() == true)
                {
                    <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                        <div class="card">
                            <div class="body bg-red">
                                <div asp-validation-summary="ModelOnly"></div>
                            </div>
                        </div>
                    </div>
                }
                <div class="row">
                    <div class="col-sm-12">
                        <div class="card-box table-responsive">

                            <div class="row clearfix">
                                <div class="col-xs-6 col-sm-3 col-md-2 col-lg-2">
                                    <a asp-action="Create" asp-controller="Client" data-loader="true" class="btn btn-primary">@Contabilidad.Resources.CommonResources.Create @Contabilidad.Resources.Models.Accounting.Client.Client.modelName</a>
                                </div>
                            </div>

                            <div id="datatable_wrapper" class="dataTables_wrapper container-fluid dt-bootstrap no-footer">

                                <div class="row">
                                </div>

                                <div class="row">
                                    <div class="col-sm-12">
                                        <table id="datatable" class="table table-striped table-bordered dataTable no-footer" style="width: 100%;" role="grid" aria-describedby="datatable_info">
                                            <thead>
                                                <tr class="headings">
                                                    <th>@Html.DisplayNameFor(Model => Model.FirstOrDefault().People)</th>
                                                    <th>@Html.DisplayNameFor(Model => Model.FirstOrDefault().BusinessName)</th>
                                                    <th>@Html.DisplayNameFor(Model => Model.FirstOrDefault().RTN)</th>
                                                    <th>@Html.DisplayNameFor(Model => Model.FirstOrDefault().Description)</th>
                                                    <th>@Contabilidad.Resources.CommonResources.Options</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                @foreach (var item in Model)
                                                {
                                                <tr>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.People)
                                                    </td>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.BusinessName)
                                                    </td>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.RTN)
                                                    </td>
                                                    <td>
                                                        @Html.DisplayFor(modelItem => item.Description)
                                                    </td>
                                                    <td>
                                                        <a asp-action="Edit" asp-route-id="@item.Id" data-loader="true" data-tooltip="tooltip" data-placement="top" title="@Contabilidad.Resources.CommonResources.Edit @Contabilidad.Resources.Models.Accounting.Client.Client.modelName" class="btn btn-xs btn-table btn-circle waves-effect waves-light-green waves-circle">
                                                            <i class="fa fa-edit"></i>
                                                        </a>
                                                        <a href="#confirm_@item.Id" data-tooltip="tooltip" data-placement="top" title="@Contabilidad.Resources.CommonResources.Delete @Contabilidad.Resources.Models.Accounting.Client.Client.modelName" class="btn btn-xs btn-table btn-circle waves-effect waves-red waves-circle" data-toggle="modal" data-target="#confirm_@item.Id">
                                                            <i class="fa fa-trash"></i>
                                                        </a>
                                                        <a asp-action="Details" asp-route-idClient="@item.Id" data-loader="true" data-tooltip="tooltip" data-placement="top" title="@Contabilidad.Resources.CommonResources.Details @Contabilidad.Resources.Models.Accounting.Client.Client.modelName" class="btn btn-xs btn-table btn-circle waves-effect waves-light-green waves-circle">
                                                            <i class="fa fa-indent"></i>
                                                        </a>
                                                        <form asp-action="Delete" asp-route-id="@item.Id">
                                                            <div class="modal fade" id="confirm_@item.Id" tabindex="-1" role="dialog">
                                                                <div class="modal-dialog" role="document">
                                                                    <div class="modal-content">
                                                                        <div class="modal-header">
                                                                            <h4 class="modal-title" id="defaultModalLabel">@Contabilidad.Resources.CommonResources.Delete @Contabilidad.Resources.Models.Accounting.Client.Client.modelName</h4>
                                                                        </div>
                                                                        <div class="modal-body">
                                                                            @Contabilidad.Resources.Models.Accounting.Client.Client.MessageDelete
                                                                        </div>
                                                                        <div class="modal-footer">
                                                                            <input type="submit" value="@Contabilidad.Resources.CommonResources.Delete" data-loader="true" class="btn btn-danger waves-effect" />
                                                                            <button type="button" class="btn btn-default waves-effect" data-dismiss="modal">@Contabilidad.Resources.CommonResources.Cancel</button>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </form>
                                                    </td>
                                                </tr>
                                                }
                                            </tbody>
                                        </table>
                                    </div>
                                </div>

                                <div class="row">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>